using System;
//using System.Drawing;
//using System.Collections;
//using System.ComponentModel;
using System.Windows.Forms;
//using System.Data;
using IBM.WMQ;

namespace MQ_Postcard
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components = null;

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tb_Message;
		private System.Windows.Forms.TextBox tb_QMName;
		private System.Windows.Forms.TextBox tb_QueueName;
		private System.Windows.Forms.ListBox lb_Status;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox tb_Sender;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox tb_Addressee;
		private System.Windows.Forms.Button b_Send;
		private System.Windows.Forms.Button b_Info;

		private int PutMessageCount= 0;
		private int GetMessageCount= 0;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label9;
		private MyDataGrid dataGrid1;
		private PostOffice po;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.CheckBox checkBox1; 

		private System.Collections.ArrayList postcards= new System.Collections.ArrayList();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			Connect();
			BindArrayListToGrid();
			this.dataGrid1.ExposedVertScrollBar.VisibleChanged +=new EventHandler(ExposedVertScrollBar_VisibleChanged);
			this.dataGrid1.CurrentCellChanged +=new EventHandler(dataGrid1_CurrentCellChanged);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
				if (po!=null) po.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.b_Send = new System.Windows.Forms.Button();
			this.tb_Message = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.tb_QMName = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.b_Info = new System.Windows.Forms.Button();
			this.lb_Status = new System.Windows.Forms.ListBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.tb_Sender = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.tb_Addressee = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.dataGrid1 = new MQ_Postcard.MyDataGrid();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.label9 = new System.Windows.Forms.Label();
			this.tb_QueueName = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// b_Send
			// 
			this.b_Send.BackColor = System.Drawing.SystemColors.InactiveCaption;
			this.b_Send.ForeColor = System.Drawing.SystemColors.HighlightText;
			this.b_Send.Location = new System.Drawing.Point(64, 72);
			this.b_Send.Name = "b_Send";
			this.b_Send.Size = new System.Drawing.Size(88, 23);
			this.b_Send.TabIndex = 4;
			this.b_Send.Text = "Send it! ";
			this.b_Send.Click += new System.EventHandler(this.b_Send_Click);
			// 
			// tb_Message
			// 
			this.tb_Message.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tb_Message.Location = new System.Drawing.Point(160, 44);
			this.tb_Message.Name = "tb_Message";
			this.tb_Message.Size = new System.Drawing.Size(416, 26);
			this.tb_Message.TabIndex = 3;
			this.tb_Message.Text = ".NET can connect to IBM systems via MQSeries !";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 49);
			this.label1.Name = "label1";
			this.label1.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label1.Size = new System.Drawing.Size(136, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "message:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tb_QMName
			// 
			this.tb_QMName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tb_QMName.Location = new System.Drawing.Point(160, 16);
			this.tb_QMName.Name = "tb_QMName";
			this.tb_QMName.Size = new System.Drawing.Size(360, 26);
			this.tb_QMName.TabIndex = 1;
			this.tb_QMName.Text = "(Default Queue Manager)";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(96, 21);
			this.label2.Name = "label2";
			this.label2.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label2.Size = new System.Drawing.Size(56, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "QMgr:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// b_Info
			// 
			this.b_Info.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.b_Info.BackColor = System.Drawing.SystemColors.InactiveCaption;
			this.b_Info.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.b_Info.Location = new System.Drawing.Point(512, 472);
			this.b_Info.Name = "b_Info";
			this.b_Info.Size = new System.Drawing.Size(88, 23);
			this.b_Info.TabIndex = 6;
			this.b_Info.Text = "About...";
			this.b_Info.Click += new System.EventHandler(this.b_Info_Click);
			// 
			// lb_Status
			// 
			this.lb_Status.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lb_Status.ItemHeight = 20;
			this.lb_Status.Location = new System.Drawing.Point(8, 496);
			this.lb_Status.Name = "lb_Status";
			this.lb_Status.Size = new System.Drawing.Size(592, 104);
			this.lb_Status.TabIndex = 7;
			this.lb_Status.TabStop = false;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 472);
			this.label3.Name = "label3";
			this.label3.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label3.Size = new System.Drawing.Size(56, 16);
			this.label3.TabIndex = 8;
			this.label3.Text = "status:";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(40, 77);
			this.label6.Name = "label6";
			this.label6.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label6.Size = new System.Drawing.Size(112, 16);
			this.label6.TabIndex = 16;
			this.label6.Text = "My Name:";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tb_Sender
			// 
			this.tb_Sender.Location = new System.Drawing.Point(160, 72);
			this.tb_Sender.Name = "tb_Sender";
			this.tb_Sender.Size = new System.Drawing.Size(112, 26);
			this.tb_Sender.TabIndex = 15;
			this.tb_Sender.Text = "dotnet";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 21);
			this.label7.Name = "label7";
			this.label7.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label7.Size = new System.Drawing.Size(136, 16);
			this.label7.TabIndex = 18;
			this.label7.Text = "to:";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tb_Addressee
			// 
			this.tb_Addressee.Location = new System.Drawing.Point(160, 16);
			this.tb_Addressee.Name = "tb_Addressee";
			this.tb_Addressee.Size = new System.Drawing.Size(168, 26);
			this.tb_Addressee.TabIndex = 17;
			this.tb_Addressee.Text = "mqi";
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.dataGrid1);
			this.groupBox1.Location = new System.Drawing.Point(8, 264);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(592, 208);
			this.groupBox1.TabIndex = 23;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Postcards Sent and Received";
			// 
			// dataGrid1
			// 
			this.dataGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.dataGrid1.CaptionVisible = false;
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(8, 38);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(576, 162);
			this.dataGrid1.TabIndex = 0;
			// 
			// groupBox2
			// 
			this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox2.Controls.Add(this.label7);
			this.groupBox2.Controls.Add(this.tb_Addressee);
			this.groupBox2.Controls.Add(this.tb_Message);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Controls.Add(this.b_Send);
			this.groupBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(8, 152);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(592, 104);
			this.groupBox2.TabIndex = 24;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Send a Postcard";
			// 
			// groupBox3
			// 
			this.groupBox3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox3.Controls.Add(this.checkBox1);
			this.groupBox3.Controls.Add(this.label4);
			this.groupBox3.Controls.Add(this.label9);
			this.groupBox3.Controls.Add(this.tb_QueueName);
			this.groupBox3.Controls.Add(this.label6);
			this.groupBox3.Controls.Add(this.tb_Sender);
			this.groupBox3.Controls.Add(this.tb_QMName);
			this.groupBox3.Controls.Add(this.label2);
			this.groupBox3.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox3.Location = new System.Drawing.Point(8, 8);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(592, 136);
			this.groupBox3.TabIndex = 25;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "General Settings";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(96, 49);
			this.label9.Name = "label9";
			this.label9.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label9.Size = new System.Drawing.Size(56, 16);
			this.label9.TabIndex = 18;
			this.label9.Text = "queue:";
			this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tb_QueueName
			// 
			this.tb_QueueName.Location = new System.Drawing.Point(160, 44);
			this.tb_QueueName.Name = "tb_QueueName";
			this.tb_QueueName.Size = new System.Drawing.Size(112, 26);
			this.tb_QueueName.TabIndex = 17;
			this.tb_QueueName.Text = "postcard";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(40, 105);
			this.label4.Name = "label4";
			this.label4.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label4.Size = new System.Drawing.Size(112, 16);
			this.label4.TabIndex = 20;
			this.label4.Text = "Auto-receive?:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(160, 100);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.TabIndex = 21;
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
			this.ClientSize = new System.Drawing.Size(608, 606);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.lb_Status);
			this.Controls.Add(this.b_Info);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = ".NET MQ Postcard app";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		private void Connect() {
			System.Windows.Forms.Cursor.Current= System.Windows.Forms.Cursors.WaitCursor;
			if (po!=null) po.Dispose();

			try {
				po= new PostOffice(this.tb_QMName.Text);
				po.QueueName= this.tb_QueueName.Text;

				if (this.checkBox1.Checked) {
					// tell the post office to start watching for us;  give it a method to invoke 
					// (FoundMessage) if it should find a matching message in the queue.  
					po.StartWatching(this.tb_Sender.Text,this,new MethodInvoker(MessageForYouSir));
				}
			} 
			catch (IBM.WMQ.MQException mqex) {
				string msg= MQUtils.MQExceptionToString(mqex);
				MessageBox.Show("Error!  " + msg);
				po=null;
			}
			if (po!= null) {
				tb_QMName.Text= po.QueueManagerName.Trim();
				AddStatus("Connected to MQ Queue Mgr (" + po.QueueManagerName.Trim() + ")");
			}
			System.Windows.Forms.Cursor.Current= System.Windows.Forms.Cursors.Default;

		}

		private void MessageForYouSir() {
			b_Get_Click(null, null);
		}


		private void b_Send_Click(object sender, System.EventArgs e) {
			System.Windows.Forms.Cursor.Current= System.Windows.Forms.Cursors.WaitCursor;
			if (po==null) Connect();

			if (po!=null) {
				try {
					Postcard p= po.SendPostcard(new Postcard(tb_Sender.Text, tb_Addressee.Text, tb_Message.Text));
					PutMessageCount++;
					RecordPostcard(p);
					AddStatus("Sent a card (" + tb_Sender.Text + "=>" + tb_Addressee.Text + ") (total sent: " + PutMessageCount + ") ...");
				}
				catch (System.Exception ex1) {
					AddStatus("Exception while sending a card (" + ex1.Message + ") ...");
				}
			}
			System.Windows.Forms.Cursor.Current= System.Windows.Forms.Cursors.Default;

		}


		private void b_Get_Click(object sender, System.EventArgs e) {
			System.Windows.Forms.Cursor.Current= System.Windows.Forms.Cursors.WaitCursor;
			if (po==null) Connect();
			if (po!=null) {
				System.DateTime sent= System.DateTime.Now;
				Postcard p= po.GetPostcard(this.tb_Sender.Text);
				if ((p!=null) && (p.status == 0)) {
					GetMessageCount++;
					RecordPostcard(p);
					Win32.Winmm.PlayWavResource("message.wav");
				}
				else
					AddStatus("Nothing in the mailbox for " + this.tb_Sender.Text + " ...");
			}
			System.Windows.Forms.Cursor.Current= System.Windows.Forms.Cursors.Default;
		}

		private void b_Info_Click(object sender, System.EventArgs e) {
			AboutBox b = new AboutBox();
			b.po= po;
			b.ShowDialog(this);			
		}

		private void RecordPostcard(Postcard p) {
			postcards.Add(p);
			UpdateSelection();
		}

		private void AddStatus(string msg) {
			lb_Status.Items.Add(msg);
			lb_Status.SelectedIndex= lb_Status.Items.Count-1;
			lb_Status.Update();
		}

		#region Logic to bind ArrayList to DataGrid
		MyColumnStyleInfo[] columnInfo= 
			new MyColumnStyleInfo[] {new MyColumnStyleInfo("Direction","Postcard",78),
										new MyColumnStyleInfo("Name","Name",70),
										new MyColumnStyleInfo("rtnMachine","Location",70),
										new MyColumnStyleInfo("posted","Postmark",90,"hh:mm:ss"),
										new MyColumnStyleInfo("message","message",240)
									};
		int totalWidthConsumed=0; 
		private void BindArrayListToGrid() { 
			dataGrid1.DataSource = postcards; 
 
			//create a custom tablestyle and add columnstyle for each column 
			DataGridTableStyle ts = new DataGridTableStyle(); 
			ts.MappingName = "ArrayList"; 
			ts.RowHeadersVisible= false;
			//columns:   direction, Name, rtnMachine, posted, message

			totalWidthConsumed=0; 
			DataGridTextBoxColumn cs= null;
			int i;
			for ( i=0; i < columnInfo.Length; i++) {				
				cs = new DataGridTextBoxColumn(); 
				cs.MappingName = columnInfo[i].MappingName; //public property name 
				cs.HeaderText = columnInfo[i].HeaderText; 
				cs.Format = columnInfo[i].Format;
				cs.Width = columnInfo[i].Width; 
				cs.TextBox.Enabled = false; // to disable editing of the data
				totalWidthConsumed += columnInfo[i].Width; 
				ts.GridColumnStyles.Add(cs); 
			}
			dataGrid1.TableStyles.Clear(); 
			dataGrid1.TableStyles.Add(ts); 
			ResetLastColumnWidth();
		}

		private void ResetLastColumnWidth() {
			// resize last column to take all remaining available space:
			if ((dataGrid1.TableStyles!=null) && (dataGrid1.TableStyles.Count >=1)) {
				DataGridTableStyle ts= dataGrid1.TableStyles[0];
				int last= columnInfo.Length -1;
				DataGridTextBoxColumn cs= (DataGridTextBoxColumn)ts.GridColumnStyles[last];
				int availableWidth = dataGrid1.Size.Width - 4; // the 4 handles the borders			
				cs.Width= availableWidth - totalWidthConsumed + columnInfo[last].Width - this.dataGrid1.VScrollBarWidth ;
			}
		}

		private void Form1_Resize(object sender, System.EventArgs e) {
			ResetLastColumnWidth();
		}

		private void ExposedVertScrollBar_VisibleChanged(object sender, EventArgs e) {
			ResetLastColumnWidth();
		}
		#endregion

		#region Logic to Auto-Select Rows as postcards arrive

		/// <summary>
		/// Tries to keep an entire row selected (Rather than a single cell in the grid).
		/// It does not quite succeed, as you can select a cell, then select it AGAIN, 
		/// and the event fires only the first time.  Whatever. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void dataGrid1_CurrentCellChanged(object sender, EventArgs e) {
			int x= this.dataGrid1.CurrentCell.RowNumber;
			dataGrid1.Select(x);  // this selects the postcard (entire row)
		}


		private CurrencyManager cm = null; 
		/// <summary>
		/// Routine to refresh the DataGrid to cause all rows in the ArrayList to be displayed. 
		/// </summary>
		private void ShowAllRows() {
			if (cm==null) {
				// reset the DataSource just once.   
				// thereafter use the CurrencyManager.   If we use the CM the 1st time, we get no 
				// data to display at all. OTOH, if we use the DS every time, we get weird DataGrid 
				// exceptions (index out of range).  If we use DS first time, and CM subsequent 
				// times, it works. 
				dataGrid1.DataSource = null; 
				dataGrid1.DataSource = postcards; 
				cm = (CurrencyManager) this.dataGrid1.BindingContext[postcards];
			} 
			else cm.Refresh();
		}

		/// <summary>
		/// Called when Postcard is added to the list.  It refreshes the grid, then selects the last row in the grid. 
		/// </summary>
		private void UpdateSelection() {
			ShowAllRows();	
			dataGrid1.Select(postcards.Count-1);  // this selects the last postcard added
			dataGrid1.ScrollToRow(postcards.Count-1);  // this scrolls to the specified row
		}
		#endregion

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e) {
			Connect();
		}
	}

	public class MyColumnStyleInfo {
		public string MappingName;
		public string HeaderText;
		public int Width;
		public string Format;
		public MyColumnStyleInfo (string name, string header, int width) {
			MappingName= name; HeaderText= header; Width= width;
		}
		public MyColumnStyleInfo (string name, string header, int width, string format) {
			MappingName= name; HeaderText= header; Width= width; Format=format;
		}
	}


	public class MyDataGrid : System.Windows.Forms.DataGrid {
		public int VScrollBarWidth {
			get {
				if (VertScrollBar.Visible) return VertScrollBar.Width;
				return 0;
			}
		}
		public ScrollBar ExposedVertScrollBar {
			get { return VertScrollBar; }
		}
		public void ScrollToRow(int theRow) {
			//
			// Expose the protected GridVScrolled method allowing you
			// to programmatically scroll the grid to a particular row.
			//
			if (DataSource != null) {
				GridVScrolled(this, new ScrollEventArgs(ScrollEventType.LargeIncrement, theRow));
			}
		}

	}
}
